<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\RSVP;
use App\Models\GuestBook;

class MainController extends Controller
{
    public function main(Request $request) {
        $rsvp = RSVP::all();
        $guestbooks = GuestBook::orderBy('created_at', 'desc')->take(5)->get();
        $totalPages = $guestbooks->count();

        $host = $request->getHost();

        return view('digital-card', compact(['rsvp', 'guestbooks', 'totalPages', 'host']));
    }

    public function saveRsvp(Request $request) {
        $host = $request->getHost();

        if ($host == 'rsvp.aliffayuna.com') {
            $vip = true;
        } else {
            $vip = false;
        }
        RSVP::create([
            'name' => $request->name,
            'member' => $request->member,
            'phone' => $request->phone,
            'is_vip' => $vip
        ]);

        session()->flash('success', 'Terima kasih kerana sudi menghadirkan diri!');

        return response()->json(['message' => 'Terima kasih kerana sudi menghadirkan diri!']);
    }

    public function saveSpeech(Request $request) {
        GuestBook::create([
            'name' => $request->name,
            'speech' => $request->speech
        ]);

        session()->flash('success', 'Terima kasih atas ucapan anda!');

        return response()->json(['message' => 'Terima kasih atas ucapan anda!']);
    }

    public function fetchGuestbook(Request $request)
    {
        $page = $request->input('page', 1);
        $guestbook = GuestBook::orderBy('created_at', 'desc')->take(5)->get()->forPage($page, 1);

        return response()->json([
            'guestbook' => view('partials.guestbook', ['entry' => $guestbook->first()])->render(),
        ]);
    }

}
